diff --git a/plugins/forkptyrouter/forkptyrouter.c b/plugins/forkptyrouter/forkptyrouter.c
index db448ec35..caced30f5 100644
--- a/plugins/forkptyrouter/forkptyrouter.c
+++ b/plugins/forkptyrouter/forkptyrouter.c
@@ -16,7 +16,7 @@
 
 extern struct uwsgi_server uwsgi;
 
-#if defined(__linux__) || defined(__GNU_kFreeBSD__)
+#if defined(__linux__) || defined(__GNU_kFreeBSD__) || defined(__HURD__)
 #include <pty.h>
 #elif defined(__APPLE__) || defined(__OpenBSD__) || defined(__NetBSD__)
 #include <util.h>
diff --git a/plugins/forkptyrouter/uwsgiplugin.py b/plugins/forkptyrouter/uwsgiplugin.py
index 887247260..f595eaf5b 100644
--- a/plugins/forkptyrouter/uwsgiplugin.py
+++ b/plugins/forkptyrouter/uwsgiplugin.py
@@ -1,7 +1,13 @@
+import os
+uwsgi_os = os.uname()[0]
+
 NAME='forkptyrouter'
 CFLAGS = []
 LDFLAGS = []
-LIBS = []
+if uwsgi_os in ('Linux', 'FreeBSD', 'GNU'):
+    LIBS = ['-lutil']
+else:
+    LIBS = []
 
 REQUIRES = ['corerouter']
 
